#!/usr/bin/perl

use LWP::UserAgent;

print "MORE FONTS!\n\n";

print "This script will download font files from the internet.\n";
print "Please be patient and wait, there are a lot of things to get.\n";
print "You can stop downloading at any time by pressing ctrl+c.\n";
print "After you have finished, you can view the files and organize\n";
print "then in anyway you like, view them and finally copy the best\n";
print "ones to /usr/share/fonts or other directory you use for fonts.\n\n";

print "Original author: Sean Parsons (sean\@thelinuxbox.org)\n";
print "Modified by: Ricardo Lenz (riclc\@hotmail.com)\n\n";


print "Now connecting to the server...\n";

my $ua = LWP::UserAgent->new;
$ua->agent("PerlBaby/0.1 ");
$ua->cookie_jar( { 'file' => "./download_import.cookies.txt" } );

my $req = HTTP::Request->new( GET => 'http://grsites.com/fonts/');

my $res = $ua->request($req);
my $data = $res->content;

print "OK, processing list of files...\n";

my @data = split( /\n/, $data );
foreach my $line ( @data )
{
  #print $line;
  $line =~ m/<nobr>\[<a href="(.*)\.shtml">Page/;
  my $file = $1;
  if( defined( $file ) )
  {
    my $req = HTTP::Request->new( GET => "http://grsites.com/fonts/$file.shtml" );
    my $res = $ua->request($req);
    my $page = $res->content;
    my @page = split( /\n/, $page );

    my $font_hash;
    foreach my $line ( @page )
    {
      $line =~ m/dir=(.*).fn=(.*)">/;
      my $dir = $1;
      my $filename = $2;
      if( defined( $dir ) and
          defined( $filename ) )
      {
        $font_hash->{$filename} = $dir;
      }
    }
    foreach my $font ( keys %{$font_hash} )
    {
      print "Downloading $font...";
	
	my $dir = $font_hash->{$font};
	my $req = HTTP::Request->new( GET => "http://www.grsites.net/modperl/fontdownload.cgi?server=216.40.241.209&dir=$dir&fn=$font" );

	my $res = $ua->request($req);
	my $font_file= $res->content;
	
      print "OK; saving file $font.ttf\n";
      
      open( FP , ">$font.ttf" );
      binmode FP;
      print FP $font_file;
      close( FP );
    }
  }
}



